// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license. 

#include <string>
#include <stdlib.h>
#include <filesystem>
#include <future>
#include "SimplygonLoader.h"


void RunReductionWithShadingNetworks(Simplygon::ISimplygon* sg)
{
	Simplygon::spSceneImporter sgSceneImporter = sg->CreateSceneImporter();
	sgSceneImporter->SetImportFilePath( "../Assets/RiggedSimplygonMan/RiggedSimplygonMan.fbx" );
	if(!sgSceneImporter->RunImport())
		throw std::exception("Failed to load RiggedSimplygonMan/RiggedSimplygonMan.fbx.");
	Simplygon::spScene sgScene = sgSceneImporter->GetScene();

	Simplygon::spReductionProcessor sgReductionProcessor = sg->CreateReductionProcessor();

	sgReductionProcessor->SetScene( sgScene );

	Simplygon::spReductionSettings sgReductionSettings = sgReductionProcessor->GetReductionSettings();
	Simplygon::spMappingImageSettings sgMappingImageSettings = sgReductionProcessor->GetMappingImageSettings();

	// Generates a mapping image which is used after the reduction to cast new materials to the new 
	// reduced object. 
	sgMappingImageSettings->SetGenerateMappingImage( true );
	sgMappingImageSettings->SetApplyNewMaterialIds( true );
	sgMappingImageSettings->SetGenerateTangents( true );
	sgMappingImageSettings->SetUseFullRetexturing( true );

	// Inject a sepia filter into the shading network for the diffuse channel for each material in the 
	// scene. 
	int materialCount = (int)sgScene->GetMaterialTable()->GetMaterialsCount();
	for (int i = 0; i < materialCount; ++i)
	{
		Simplygon::spMaterial sgMaterial = sgScene->GetMaterialTable()->GetMaterial(i);

		Simplygon::spShadingNode sgMaterialShadingNode = sgMaterial->GetShadingNetwork("Diffuse");
		Simplygon::spShadingColorNode sgSepiaColor1 = sg->CreateShadingColorNode();
		Simplygon::spShadingColorNode sgSepiaColor2 = sg->CreateShadingColorNode();
		Simplygon::spShadingColorNode sgSepiaColor3 = sg->CreateShadingColorNode();
		Simplygon::spShadingColorNode sgRedFilter = sg->CreateShadingColorNode();
		Simplygon::spShadingColorNode sgGreenFilter = sg->CreateShadingColorNode();
		Simplygon::spShadingColorNode sgBlueFilter = sg->CreateShadingColorNode();
		Simplygon::spShadingDot3Node sgSepiaDot1 = sg->CreateShadingDot3Node();
		Simplygon::spShadingDot3Node sgSepiaDot2 = sg->CreateShadingDot3Node();
		Simplygon::spShadingDot3Node sgSepiaDot3 = sg->CreateShadingDot3Node();
		Simplygon::spShadingMultiplyNode sgSepiaMul1 = sg->CreateShadingMultiplyNode();
		Simplygon::spShadingMultiplyNode sgSepiaMul2 = sg->CreateShadingMultiplyNode();
		Simplygon::spShadingMultiplyNode sgSepiaMul3 = sg->CreateShadingMultiplyNode();
		Simplygon::spShadingAddNode sgSepiaAdd1 = sg->CreateShadingAddNode();
		Simplygon::spShadingAddNode sgSepiaAdd2 = sg->CreateShadingAddNode();

		sgSepiaColor1->SetColor(0.393f, 0.769f, 0.189f, 1.0f);
		sgSepiaColor2->SetColor(0.349f, 0.686f, 0.168f, 1.0f);
		sgSepiaColor3->SetColor(0.272f, 0.534f, 0.131f, 1.0f);
		sgRedFilter->SetColor(1.0f, 0.0f, 0.0f, 1.0f);
		sgGreenFilter->SetColor(0.0f, 1.0f, 0.0f, 1.0f);
		sgBlueFilter->SetColor(0.0f, 0.0f, 1.0f, 1.0f);

		sgSepiaDot1->SetInput(0, sgSepiaColor1);
		sgSepiaDot1->SetInput(1, sgMaterialShadingNode);
		sgSepiaDot2->SetInput(0, sgSepiaColor2);
		sgSepiaDot2->SetInput(1, sgMaterialShadingNode);
		sgSepiaDot3->SetInput(0, sgSepiaColor3);
		sgSepiaDot3->SetInput(1, sgMaterialShadingNode);
		sgSepiaMul1->SetInput(0, sgSepiaDot1);
		sgSepiaMul1->SetInput(1, sgRedFilter);
		sgSepiaMul2->SetInput(0, sgSepiaDot2);
		sgSepiaMul2->SetInput(1, sgGreenFilter);
		sgSepiaMul3->SetInput(0, sgSepiaDot3);
		sgSepiaMul3->SetInput(1, sgBlueFilter);
		sgSepiaAdd1->SetInput(0, sgSepiaMul1);
		sgSepiaAdd1->SetInput(1, sgSepiaMul2);
		sgSepiaAdd2->SetInput(0, sgSepiaAdd1);
		sgSepiaAdd2->SetInput(1, sgSepiaMul3);

		sgMaterial->SetShadingNetwork("Diffuse", sgSepiaAdd2);

	}

	// Start the reduction process. 
	sgReductionProcessor->RunProcessing();

	// Setup and run the diffuse material casting. 
	Simplygon::spColorCaster sgDiffuseCaster = sg->CreateColorCaster();
	sgDiffuseCaster->SetMappingImage( sgReductionProcessor->GetMappingImage() );
	sgDiffuseCaster->SetSourceMaterials( sgScene->GetMaterialTable() );
	sgDiffuseCaster->SetSourceTextures( sgScene->GetTextureTable() );
	sgDiffuseCaster->SetOutputFilePath( "DiffuseTexture" );

	Simplygon::spColorCasterSettings sgDiffuseCasterSettings = sgDiffuseCaster->GetColorCasterSettings();
	sgDiffuseCasterSettings->SetMaterialChannel( "Diffuse" );
	sgDiffuseCasterSettings->SetOutputImageFileFormat( Simplygon::EImageOutputFormat::PNG );

	sgDiffuseCaster->RunProcessing();
	std::string diffuseTextureFilePath = sgDiffuseCaster->GetOutputFilePath();

	// Update scene with new casted texture. 
	Simplygon::spMaterialTable sgMaterialTable = sg->CreateMaterialTable();
	Simplygon::spTextureTable sgTextureTable = sg->CreateTextureTable();
	Simplygon::spMaterial sgMaterial = sg->CreateMaterial();
	Simplygon::spTexture sgDiffuseTexture = sg->CreateTexture();
	sgDiffuseTexture->SetName( "Diffuse" );
	sgDiffuseTexture->SetFilePath( diffuseTextureFilePath.c_str() );
	sgTextureTable->AddTexture( sgDiffuseTexture );

	Simplygon::spShadingTextureNode sgDiffuseTextureShadingNode = sg->CreateShadingTextureNode();
	sgDiffuseTextureShadingNode->SetTexCoordLevel( 0 );
	sgDiffuseTextureShadingNode->SetTextureName( "Diffuse" );

	sgMaterial->AddMaterialChannel( "Diffuse" );
	sgMaterial->SetShadingNetwork( "Diffuse", sgDiffuseTextureShadingNode );

	sgMaterialTable->AddMaterial( sgMaterial );

	sgScene->GetTextureTable()->Clear();
	sgScene->GetMaterialTable()->Clear();
	sgScene->GetTextureTable()->Copy(sgTextureTable);
	sgScene->GetMaterialTable()->Copy(sgMaterialTable);

	Simplygon::spSceneExporter  sgSceneExporter = sg->CreateSceneExporter();
	sgSceneExporter->SetScene(sgScene);
	sgSceneExporter->SetExportFilePath( "ReductionOutput.fbx" );
	if(!sgSceneExporter->RunExport())
		throw std::exception("Failed to save ReductionOutput.fbx.");

}

void main()
{
	Simplygon::ISimplygon* sg = NULL;
	Simplygon::EErrorCodes initval = Simplygon::Initialize( &sg );
	if( initval != Simplygon::EErrorCodes::NoError )
	{
		return;
	}

	RunReductionWithShadingNetworks(sg);

	Simplygon::Deinitialize(sg);
}

